# GnuTLS Application Helpers

**API Group:** `xmlsec_gnutls_app`

High-level application helpers for the GnuTLS back-end.

Application support functions for GnuTLS.

Common functions for the xmlsec1 command-line utility for GnuTLS.

## Functions

### `xmlSecGnuTLSAppInit`

```c
int xmlSecGnuTLSAppInit(const char *config);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L29)

Initializes the GnuTLS crypto engine.

General crypto engine initialization. This function is used by the XMLSec command-line utility and is called before the `xmlSecInit` function.

**Parameters:**

- `config` — the path to GnuTLS configuration (unused).


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppShutdown`

```c
int xmlSecGnuTLSAppShutdown(void);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L30)

Shuts down the GnuTLS crypto engine.

General crypto engine shutdown. This function is used by the XMLSec command-line utility and is called after the `xmlSecShutdown` function.

**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppDefaultKeysMngrInit`

```c
int xmlSecGnuTLSAppDefaultKeysMngrInit(xmlSecKeysMngrPtr mngr);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L37)

Initializes the default key manager for GnuTLS.

Initializes `mngr` with simple keys store `xmlSecGnuTLSKeysStoreId` and a default GnuTLS crypto key data stores.

**Parameters:**

- `mngr` — the pointer to keys manager.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppDefaultKeysMngrAdoptKey`

```c
int xmlSecGnuTLSAppDefaultKeysMngrAdoptKey(xmlSecKeysMngrPtr mngr, xmlSecKeyPtr key);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L38)

Adds `key` to the keys manager.

Adds `key` to the keys manager `mngr` created with `xmlSecGnuTLSAppDefaultKeysMngrInit` function.

**Parameters:**

- `mngr` — the pointer to keys manager.
- `key` — the pointer to key.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppDefaultKeysMngrVerifyKey`

```c
int xmlSecGnuTLSAppDefaultKeysMngrVerifyKey(xmlSecKeysMngrPtr mngr, xmlSecKeyPtr key, xmlSecKeyInfoCtxPtr keyInfoCtx);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L40)

Verifies `key` using the keys manager.

Verifies `key` with the keys manager `mngr` created with `xmlSecCryptoAppDefaultKeysMngrInit` function:

- Checks that key certificate is present
- Checks that key certificate is valid

Adds `key` to the keys manager `mngr` created with `xmlSecCryptoAppDefaultKeysMngrInit` function.

**Parameters:**

- `mngr` — the pointer to keys manager.
- `key` — the pointer to key.
- `keyInfoCtx` — the key info context for verification.


**Returns:** 1 if key is verified, 0 otherwise, or a negative value if an error occurs.

---

### `xmlSecGnuTLSAppDefaultKeysMngrLoad`

```c
int xmlSecGnuTLSAppDefaultKeysMngrLoad(xmlSecKeysMngrPtr mngr, const char *uri);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L43)

Loads the XML keys file into the keys manager.

Loads XML keys file from `uri` to the keys manager `mngr` created with `xmlSecGnuTLSAppDefaultKeysMngrInit` function.

**Parameters:**

- `mngr` — the pointer to keys manager.
- `uri` — the uri.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppDefaultKeysMngrSave`

```c
int xmlSecGnuTLSAppDefaultKeysMngrSave(xmlSecKeysMngrPtr mngr, const char *filename, xmlSecKeyDataType type);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L45)

Saves keys from `mngr` to XML keys file.

**Parameters:**

- `mngr` — the pointer to keys manager.
- `filename` — the destination filename.
- `type` — the type of keys to save (public/private/symmetric).


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppKeysMngrCertLoad`

```c
int xmlSecGnuTLSAppKeysMngrCertLoad(xmlSecKeysMngrPtr mngr, const char *filename, xmlSecKeyDataFormat format, xmlSecKeyDataType type);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L49)

Reads a cert from a file and adds to the key store.

Reads cert from `filename` and adds to the list of trusted or known untrusted certs in `store`.

**Parameters:**

- `mngr` — the keys manager.
- `filename` — the certificate file.
- `format` — the certificate file format.
- `type` — the flag that indicates is the certificate in `filename` trusted or not.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppKeysMngrCertLoadMemory`

```c
int xmlSecGnuTLSAppKeysMngrCertLoadMemory(xmlSecKeysMngrPtr mngr, const xmlSecByte *data, xmlSecSize dataSize, xmlSecKeyDataFormat format, xmlSecKeyDataType type);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L53)

Reads cert from buffer and adds to the key store.

Reads cert from binary buffer `data` and adds to the list of trusted or known untrusted certs in `store`.

**Parameters:**

- `mngr` — the keys manager.
- `data` — the certificate binary data.
- `dataSize` — the certificate binary data size.
- `format` — the certificate file format.
- `type` — the flag that indicates is the certificate trusted or not.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppKeysMngrCrlLoad`

```c
int xmlSecGnuTLSAppKeysMngrCrlLoad(xmlSecKeysMngrPtr mngr, const char *filename, xmlSecKeyDataFormat format);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L58)

Reads CRLs from a file and adds to the store.

Reads crls from `filename` and adds to the list of crls in `store`.

**Parameters:**

- `mngr` — the keys manager.
- `filename` — the CRL file.
- `format` — the CRL file format.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppKeysMngrCrlLoadMemory`

```c
int xmlSecGnuTLSAppKeysMngrCrlLoadMemory(xmlSecKeysMngrPtr mngr, const xmlSecByte *data, xmlSecSize dataSize, xmlSecKeyDataFormat format);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L61)

Reads CRL from buffer and adds to the key store.

Reads CRL from binary buffer `data` and adds to the list of trusted or known untrusted CRL in `store`.

**Parameters:**

- `mngr` — the keys manager.
- `data` — the CRL binary data.
- `dataSize` — the CRL binary data size.
- `format` — the CRL file format.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppKeysMngrCrlLoadAndVerify`

```c
int xmlSecGnuTLSAppKeysMngrCrlLoadAndVerify(xmlSecKeysMngrPtr mngr, const char *filename, xmlSecKeyDataFormat format, xmlSecKeyInfoCtxPtr keyInfoCtx);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L65)

Loads and verifies a CRL from a file.

Atomically loads and verifies a CRL from `filename`.

**Parameters:**

- `mngr` — the keys manager.
- `filename` — the CRL filename.
- `format` — the CRL format (PEM or DER).
- `keyInfoCtx` — the key info context for verification parameters.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppKeyLoadEx`

```c
xmlSecKeyPtr xmlSecGnuTLSAppKeyLoadEx(const char *filename, xmlSecKeyDataType type, xmlSecKeyDataFormat format, const char *pwd, void *pwdCallback, void *pwdCallbackCtx);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L78)

Reads a key from a file.

**Parameters:**

- `filename` — the key filename.
- `type` — the expected key type.
- `format` — the key file format.
- `pwd` — the key file password.
- `pwdCallback` — the key password callback.
- `pwdCallbackCtx` — the user context for password callback.


**Returns:** pointer to the key or NULL if an error occurs.

---

### `xmlSecGnuTLSAppKeyLoadMemory`

```c
xmlSecKeyPtr xmlSecGnuTLSAppKeyLoadMemory(const xmlSecByte *data, xmlSecSize dataSize, xmlSecKeyDataFormat format, const char *pwd, void *pwdCallback, void *pwdCallbackCtx);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L84)

Reads a key from the memory buffer.

**Parameters:**

- `data` — the binary key data.
- `dataSize` — the size of binary key.
- `format` — the key file format.
- `pwd` — the key file password.
- `pwdCallback` — the key password callback.
- `pwdCallbackCtx` — the user context for password callback.


**Returns:** pointer to the key or NULL if an error occurs.

---

### `xmlSecGnuTLSAppPkcs12Load`

```c
xmlSecKeyPtr xmlSecGnuTLSAppPkcs12Load(const char *filename, const char *pwd, void *pwdCallback, void *pwdCallbackCtx);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L91)

Reads key and certificates from PKCS12 file.

Reads a key and all associated certificates from the PKCS12 file. For uniformity, call `xmlSecGnuTLSAppKeyLoadEx` instead of this function. Pass in format=xmlSecKeyDataFormatPkcs12.

**Parameters:**

- `filename` — the PKCS12 key filename.
- `pwd` — the PKCS12 file password.
- `pwdCallback` — the password callback.
- `pwdCallbackCtx` — the user context for password callback.


**Returns:** pointer to the key or NULL if an error occurs.

---

### `xmlSecGnuTLSAppPkcs12LoadMemory`

```c
xmlSecKeyPtr xmlSecGnuTLSAppPkcs12LoadMemory(const xmlSecByte *data, xmlSecSize dataSize, const char *pwd, void *pwdCallback, void *pwdCallbackCtx);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L95)

Reads key and certs from PKCS12 memory buffer.

Reads a key and all associated certificates from the PKCS12 data in the memory buffer. For uniformity, call xmlSecGnuTLSAppKeyLoadMemory instead of this function. Pass in format=xmlSecKeyDataFormatPkcs12.

**Parameters:**

- `data` — the PKCS12 binary data.
- `dataSize` — the PKCS12 binary data size.
- `pwd` — the PKCS12 file password.
- `pwdCallback` — the password callback.
- `pwdCallbackCtx` — the user context for password callback.


**Returns:** pointer to the key or NULL if an error occurs.

---

### `xmlSecGnuTLSAppKeyCertLoad`

```c
int xmlSecGnuTLSAppKeyCertLoad(xmlSecKeyPtr key, const char *filename, xmlSecKeyDataFormat format);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L100)

Reads a certificate from a file and adds to key.

Reads the certificate from `filename` and adds it to key.

**Parameters:**

- `key` — the pointer to key.
- `filename` — the certificate filename.
- `format` — the certificate file format.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppKeyCertLoadMemory`

```c
int xmlSecGnuTLSAppKeyCertLoadMemory(xmlSecKeyPtr key, const xmlSecByte *data, xmlSecSize dataSize, xmlSecKeyDataFormat format);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L103)

Reads a certificate from memory and adds to key.

Reads the certificate from memory buffer and adds it to key.

**Parameters:**

- `key` — the pointer to key.
- `data` — the certificate binary data.
- `dataSize` — the certificate binary data size.
- `format` — the certificate file format.


**Returns:** 0 on success or a negative value otherwise.

---

### `xmlSecGnuTLSAppGetDefaultPwdCallback`

```c
void * xmlSecGnuTLSAppGetDefaultPwdCallback(void);
```

*Source:* [include/xmlsec/gnutls/app.h](https://github.com/lsh123/xmlsec/blob/1.3.11/include/xmlsec/gnutls/app.h#L108)

Gets default password callback.

**Returns:** default password callback.

---
